package ${package.Controller};

import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

import cn.hutool.core.bean.BeanUtil;
import com.github.zuihou.base.R;
import com.github.zuihou.base.controller.SuperCacheController;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.github.zuihou.base.request.PageParams;
import com.github.zuihou.database.mybatis.conditions.query.LbqWrapper;
import com.github.zuihou.database.mybatis.conditions.query.QueryWrap;
import com.github.zuihou.log.annotation.SysLog;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;


<#assign tableComment = "${table.comment!''}"/>
<#if table.comment?? && table.comment!?contains('\n')>
    <#assign tableComment = "${table.comment!?substring(0,table.comment?index_of('\n'))?trim}"/>
</#if>
/**
 * <p>
 * 前端控制器
 * ${table.comment!?replace("\n","\n * ")}
 * </p>
 *
 * @author ${author}
 * @date ${date}
 */
@Slf4j
@Validated
<#if restControllerStyle>
@RestController
<#else>
@Controller
</#if>
@RequestMapping("<#if package.ModuleName?? && package.ModuleName!=''>/${package.ModuleName}</#if>/<#if controllerMappingHyphenStyle??>${controllerMappingHyphen}<#else>${table.entityPath}</#if>")
<#if swagger2>
@Api(value = "${entity}", tags = "${tableComment}")
</#if>
@SysLog(enabled = true)
<#if kotlin>
    class ${table.controllerName}<#if superControllerClass??> : ${superControllerClass}()</#if>
<#else>
    <#if superControllerClass??>
public class ${table.controllerName} extends SuperCacheController<${table.serviceName},Long, <#list table.commonFields as field><#if field.keyFlag>${field.propertyType}</#if></#list><#list table.fields as field><#if field.keyFlag>${field.propertyType}</#if></#list>, ${entity}, ${entity}PageQuery, ${entity}SaveDTO, ${entity}UpdateDTO> {
    <#else>
public class ${table.controllerName} {
    </#if>

<#if superControllerClass??>

    @Override
    public void query(PageParams<${entity}PageQuery> params, IPage<${entity}> page, Long defSize) {
        ${entity}PageQuery data = params.getModel();
        QueryWrap<${entity}> wrap = handlerWrapper(null, params);
        LbqWrapper<${entity}> wrapper = wrap.lambda();
        ${entity} en = BeanUtil.toBean(data, ${entity}.class);

        <#--wrapper.like(ToolManagement::getName,shelves.getName())
        .eq(ToolManagement::getStatus,shelves.getStatus())
        .eq(ToolManagement::getZoneId,shelves.getZoneId())
        .orderByDesc(ToolManagement::getCreateTime);-->
        baseService.pageList(page, wrapper);
    }


    /**
    * 保存
    */
    @Override
    public R<${entity}> handlerSave(${entity}SaveDTO model) {
        ${entity} common = baseService.save(model);
        return success(common);
    }

    /**
    *
    * 修改
    */
    @ApiOperation(value = "修改${tableComment}", notes = "修改${tableComment}")
    @PostMapping("/update")
    public R<${entity}> update(@RequestBody ${entity}UpdateDTO model) {
        ${entity} common = baseService.update(model);
        return success(common);
    }

    /**
    *
    * 删除
    */
    @ApiOperation(value = "删除${tableComment}", notes = "删除${tableComment}")
    @PostMapping("/delete")
    public R<Boolean> delete(@RequestBody ${entity} model) {
        return success(baseService.delete(model));
    }

</#if>
}
</#if>
