package ${package.ServiceImpl};


import lombok.extern.slf4j.Slf4j;
<#if superServiceImplClass?? && superServiceImplClass == "SuperCacheServiceImpl">
import org.springframework.aop.framework.AopContext;
import org.springframework.cache.annotation.CacheConfig;
</#if>
import org.springframework.stereotype.Service;

/**
 * <p>
 * 业务实现类
 * ${table.comment!?replace("\n","\n * ")}
 * </p>
 *
 * @author ${author}
 * @date ${date}
 */
@Slf4j
@Service
<#if superServiceImplClass?? && superServiceImplClass == "SuperCacheServiceImpl">
@CacheConfig(cacheNames = ${table.serviceImplName}.${entity?upper_case})
</#if>
<#if kotlin>
open class ${table.serviceImplName} : ${superServiceImplClass}<${table.mapperName}, ${entity}>(), ${table.serviceName} {
}
<#else>
public class ${table.serviceImplName} extends SuperCacheServiceImpl<${table.mapperName}, ${entity}> implements ${table.serviceName} {
    @Override
    public IPage<${entity}> pageList(IPage page, LbqWrapper<${entity}> wrapper) {
        return baseMapper.pageList(page, wrapper, new DataScope());
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ${entity} save(${entity}SaveDTO data) {
        ${entity} model = BeanPlusUtil.toBean(data, ${entity}.class);
        save(model);
        return model;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public ${entity} update(${entity}UpdateDTO data) {
        ${entity} model = BeanPlusUtil.toBean(data, ${entity}.class);
        updateById(model);
        return model;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public Boolean delete(${entity} model) {
        return removeById(model);
    }
}
</#if>
